%global svnversion 16
%global soname     libclrun.so.%{version}.%{svnversion}

Name:           opencl-utils
Version:        0
Release:        14.svn%{svnversion}%{?dist}
Summary:        Useful OpenCL tools and utilities

License:        MIT
Url:            http://code.google.com/p/%{name}
###Commands to grab source from svn:
#svn co -r 16 http://opencl-utils.googlecode.com/svn/trunk/ opencl-utils
#tar -Jcv --exclude-vcs -f opencl-utils.tar.xz opencl-utils
#rm -f -r opencl-utils
Source0:         %{name}.tar.xz
Source1:         %{name}-README.fedora
Source2:         %{name}.pc
#Kudos to Alec Leamas: http://code.google.com/p/opencl-utils/issues/detail?id=2
Patch0:         %{name}-fixupmakefile.patch

BuildRequires:  mesa-libGL-devel
BuildRequires:  perl

%package        devel
Summary:        Devel files for OpenCL Utils
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       pkgconfig

%description
#Modified from the homepage
OpenCL Utils is a project that aims to create various tools and utilities to
make the use of OpenCL more useful and efficient, such as: useful functions,
optimization hints and common kernel templates. This package currently only
contains CLRun, which allows for dynamic loading of OpenCL.

%description devel
This package includes the headers files for OpenCL Utils.
OpenCL Utils is a project that aims to create various tools and utilities to
make the use of OpenCL more useful and efficient, such as: useful functions,
optimization hints and common kernel templates.

%prep
%setup -q -n %{name}
%patch0 -p0
cp -a %{SOURCE1} ./README.fedora
#Fixes for Example compiling
sed -i -e 's/@version@/%{version}/' -e 's|@prefix@|%{_prefix}|' %{SOURCE2}
sed -i 's/\r//' examples/clrun-example/example2.cpp
sed -i '/ldl/c\\tgcc $(pkg-config --cflags --libs opencl-utils) example1.c' examples/clrun-example/Makefile
sed -i '/lclrun/c\\tg++ $(pkg-config --cflags --libs opencl-utils) example2.cpp' examples/clrun-example/Makefile
#To avoid copying a windows build file later on
rm -f examples/OCLUtilsExamples.vcproj
#Clean the generated files before compiling
cd src/clrun/
make clean

%build
cd src/clrun/
env CFLAGS="%{optflags} -fPIC -Wl,-soname=%{soname}" make

%install
mkdir -p %{buildroot}%{_libdir} %{buildroot}%{_includedir}/%{name}/clrun/
cp -a src/clrun/*.h %{buildroot}%{_includedir}/%{name}/clrun/
cp -a src/clrun/*.c %{buildroot}%{_includedir}/%{name}/clrun/
cp -a src/clrun/Makefile %{buildroot}%{_includedir}/%{name}/clrun/
cp -a src/clrun/generateClRun.pl %{buildroot}%{_includedir}/%{name}/clrun/
cp -r src/include %{buildroot}%{_includedir}/%{name}/
install -m 0644 -D %{SOURCE2} %{buildroot}%{_libdir}/pkgconfig/%{name}.pc
#install the library and the links
soname=%{soname}
install -p -D -m 0755 src/clrun/${soname%%.*.*} %{buildroot}%{_libdir}/%{soname}
cd %{buildroot}%{_libdir}
ln -sf  $soname ${soname%%.*}
ln -sf  $soname ${soname%%.*.*}

%files
%{_libdir}/*.so.*

%files devel
%doc examples/* README.fedora
%{_includedir}/%{name}/include/CL
%{_includedir}/%{name}/clrun/
%{_includedir}/%{name}/include/clrun.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%changelog
* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-14.svn16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-13.svn16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-12.svn16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 17 2013 Petr Pisar <ppisar@redhat.com> - 0-11.svn16
- Perl 5.18 rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-10.svn16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-9.svn16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Jun 27 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-8.svn16
- Fixed a typo (creates a redundant empty folders)
- Fixed missing source devel files
- Added missing buildrequire perl

* Sun Jun 24 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-7.svn16
- Reverted reorganizing of source files due to compilation problems

* Sun Jun 24 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-6.svn16
- Silenced an rpmlint mixed-use-of-spaces-and-tabs warning
- Implimented reserving timestamps
- Renamed README source file with prefix
- Added bug report for patch0

* Sun Jun 24 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-5.svn16
- Various simplications and fixes of the package structure
- Added cleaning of generated files to prep
- Reorganizing of source files
- Added compiling README and added examples as documentation
- Fixed up examples, included packagecfg

* Sun Apr 8 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-4.svn16
- Removed all non headers from devel excluding examples
- More tweaks to the makefile (clrun)
- Various improvements/cleanups
- OpenCLpointers patch dropped due to compiling issues (functions fine without)
- trimwhitespace patch dropped due to little purpose

* Thu Apr 5 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-3.svn16
- Fixed soname/ldconfig issue
- Typo in the date of the last changelog

* Thu Apr 5 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-2.svn16
- Changed sub-packages to something more suitable
- Patched the makefile a little more
- Fixed requirements

* Sun Mar 25 2012 Jeremy Newton <alexjnewt@hotmail.com> - 0-1.svn16
- Initial package SPEC created

